
#include <stdio.h>
#include <propeller.h>

#include "FilterIIRcordic.h"

#define P2_TARGET_MHZ 180
#include "sys/p2es_clock.h"

#ifndef _BAUD
#define _BAUD 230400
#endif

#define pinLedG 6
#define pinLedY 7
#define pinLedR 8

iirFilter lp, hp;
// 2nd order Bessel filter, LP=low pass, HP=high pass
float lpa[] = {
        0.0540612657669160,
        0.1081225315338320,
        0.0540612657669160
    };
float lpb[] = {
        1.0000000000000000,
        -1.1459590765368437,
        0.3622041772356034
    };
float hpa[] = {
        0.6270408414142428,
        -1.2540816828284858,
        0.6270408414142428
    };

float hpb[] = {
        1.0000000000000000,
        -1.1459590765968510,
        0.3622041772737749
    };
// filter coefficients calculated with WinFilter (www.winfilter.20m.com) by Adrian Kundert

void main()
{
    clkset(_SETFREQ, _CLOCKFREQ);
    _setbaud(_BAUD);
    printf("IIR filter test: clockmode is $%x, clock frequency %u Hz\n", _SETFREQ, _CLOCKFREQ);
    _pinl (pinLedY);
    _pinh (pinLedG);

    lp.SetCoefficients (lpa, lpb, 2);
    hp.SetCoefficients (hpa, hpb, 2);
    for (int i=0; i<100; i++)
    {
      float inp= (i>10)?1.0f:0.0f; // test step response
      float r1= lp.Output (inp);
      float r2= hp.Output (inp);
      printf ("lp=%f hp=%f\n", r1, r2);
    }
    int test= CoeffToArcSin (1.0);
    _pinh (pinLedY);
}
